package hatelace;

public class Computer {
    private Memory memory;
    private Program program;

    public Computer(Memory Memory) {
        this.memory = Memory;
    }

    public void load(Program program) {
        this.program = program;
    }

    public void run() {
        // Note that the instructions themselves are responsible for incrementing the PC
        for(ProgramCounter PC = new ProgramCounter(); PC.getPC() < this.program.size(); ) {
            program.getInstructions()[PC.getPC()].execute(this.memory, PC);
        }
    }
}
