package hatelace;

import hatelace.instructions.*;

public class Main {
    public static void main(String[] args) {
        System.out.println("Starting...");

        Memory memory = new IntMemory(64); // 64 words of memory
        Computer computer = new Computer(memory);
        Program program = new Program(new Instruction[] {
            new Add(1, 1, 0), // Store 1 + 1 in address 0
            new Mul(2, 2, 1),  // Store 2 * 2 in address 1
            new Copy(new IntWord(3), new Address(2)) // Store 3 in address 2
        });
        computer.load(program);
        computer.run();
        memory.dump();

        // Print the program
        System.out.println("Program:");
        for (Instruction instruction : program.getInstructions()) {
            System.out.println(instruction);
        }

        System.out.println("Completed");
    }
}
